<?php
// $Id: weblinks.admin.inc,v 1.5 2008/07/10 05:11:10 rmiddle Exp $

/**
 * @file
 * Settings form.
 */

/**
 * Module settings page.
 */
function weblinks_admin_settings(&$form_state) {
  $form['weblinks_external'] = array(
    '#type' => 'radios',
    '#title' => t('Web links open in new windows'),
    '#default_value' => variable_get("weblinks_external", 1),
    '#options' => array('no', 'yes'),
    '#required' => FALSE,
    '#weight' => -13,
  );
  $form['weblinks_pagedesc'] = array(
    '#type' => 'textarea',
    '#title' => t('Page information'),
    '#cols' => 40,
    '#rows' => 5,
    '#default_value' => variable_get("weblinks_pagedesc", NULL),
    '#description' => t('This description will appear at the top of the links page'),
    '#required' => FALSE,
    '#weight' => -12,
  );
  $form['weblinks_simplelinks'] = array(
    '#type' => 'checkbox',
    '#title' => t('Use Simple Links'),
    '#default_value' => variable_get("weblinks_simplelinks", 0),
    '#description' => t('Enable this if you only want links on the main page'),
    '#required' => TRUE,
    '#weight' => -11,
  );
  $form['weblinks_urlnode'] = array(
    '#type' => 'radios',
    '#title' => t('Links lead URL or to Web Link node'),
    '#default_value' => variable_get("weblinks_urlnode", 'url'),
    '#description' => t('Most people will want to leave this as URL'),
    '#options' => array('url' => 'URL', 'node' => 'node'),
    '#required' => FALSE,
    '#weight' => -10,
  );
  $form['weblinks_block_urlnode'] = array(
    '#type' => 'radios',
    '#title' => t('Block links lead URL or to Web Link node'),
    '#default_value' => variable_get("weblinks_block_urlnode", 'url'),
    '#description' => t('Most people will want to leave this as URL'),
    '#options' => array('url' => 'URL', 'node' => 'node'),
    '#required' => FALSE,
    '#weight' => -9,
  );
  $form['weblinks_catdesc'] = array(
    '#type' => 'checkbox',
    '#title' => t('Display link category descriptions'),
    '#default_value' => variable_get("weblinks_catdesc", 1),
    '#required' => FALSE,
    '#weight' => -8,
  );
  $form['weblinks_subcatdesc'] = array(
    '#type' => 'checkbox',
    '#title' => t('Display link sub-category descriptions'),
    '#default_value' => variable_get("weblinks_subcatdesc", 0),
    '#required' => FALSE,
    '#weight' => -7,
  );
  $form['weblinks_linkdesc'] = array(
    '#type' => 'checkbox',
    '#title' => t('Display individual link descriptions'),
    '#default_value' => variable_get("weblinks_linkdesc", 1),
    '#required' => FALSE,
    '#weight' => -6,
  );
  $form['weblinks_linkinfo'] = array(
    '#type' => 'checkbox',
    '#title' => t('Display link information'),
    '#default_value' => variable_get("weblinks_linkinfo", 1),
    '#description' => t('This displays link author, publish date, and revision date'),
    '#required' => FALSE,
    '#weight' => -5,
  );
  $form['weblinks_nofollow'] = array(
    '#type' => 'checkbox',
    '#title' => t('Spam link deterrent'),
    '#default_value' => variable_get('weblinks_nofollow', FALSE),
    '#description' => t('If enabled, Drupal will add rel="nofollow" to all links, as a measure to reduce the effectiveness of spam links. Note: this will also prevent valid links from being followed by search engines, therefore it is likely most effective when enabled for anonymous users.'),
    '#weight' => -4,
    );
  $form['weblinks_maxfrontdepth'] = array(
    '#type' => 'textfield',
    '#title' => t('Maximum category depth (front page)'),
    '#default_value' => variable_get("weblinks_maxfrontdepth", 1),
    '#description' => t('This is affects how many subcategories, if any, will display on the main links page'),
    '#required' => FALSE,
    '#size' => 2,
    '#weight' => -3,
  );
  $form['weblinks_maxdepth'] = array(
    '#type' => 'textfield',
    '#title' => t('Maximum category depth'),
    '#default_value' => variable_get("weblinks_maxdepth", 1),
    '#description' => t('This is affects how many subcategories, if any, will display on every other links page'),
    '#required' => FALSE,
    '#size' => 2,
    '#weight' => -2
  );
  $form['weblinks_clickthru'] = array(
    '#type' => 'textfield',
    '#title' => t('User click through'),
    '#default_value' => variable_get("weblinks_clickthru", NULL),
    '#description' => t('How many clicks a user can make before all the menus are automatically expanded. Leave blank if you do not want to set a limit.'),
    '#required' => FALSE,
    '#size' => 2,
    '#weight' => -1,
  );

  // Get the weblinks categories to add to the blogroll
  $result = db_query('SELECT tid, name FROM {term_data} WHERE vid = %d ORDER BY weight, name', _weblinks_get_vocid());

  while ($row = db_fetch_object($result)) {
    // Set which link categories get displayed on the links page

    $form[$row->tid] = array(
      '#type' => 'fieldset',
      '#title' => $row->name,
      '#collapsible' => TRUE,
      '#collapsed' => TRUE,
      '#weight' => 0,
    );

    $form[$row->tid]['weblinks_page_'. $row->tid] = array(
      '#type' => 'checkbox',
      '#title' => $row->name,
      '#default_value' => variable_get('weblinks_page_'. $row->tid, 1),
      '#required' => FALSE,
      '#description' => t('Check to enable this category'),
    );

    // Set the maximum number of links to display for each category
    $form[$row->tid]['weblinks_maxdisp_'. $row->tid] = array(
      '#type' => 'textfield',
      '#title' => t('Maximum links to display'),
      '#default_value' => variable_get('weblinks_maxdisp_'. $row->tid, NULL),
      '#size' => 2,
      '#required' => FALSE,
      '#description' => t('Leave blank if you would not like to limit the number of links displayed'),
    );

    // Set the maximum number of links to display in the block for each category
    $form[$row->tid]['weblinks_maxdisp_block_'. $row->tid] = array(
      '#type' => 'textfield',
      '#title' => t('Maximum block entries to display'),
      '#default_value' => variable_get('weblinks_maxdisp_block_'. $row->tid, NULL),
      '#size' => 2,
      '#required' => FALSE,
      '#description' => t('Leave blank if you would not like to limit the number of links displayed'),
    );
  }
  return system_settings_form($form);
}
